#!/usr/bin/env perl

# $Id: insertjamofiller.pl,v 1.7 2012/11/14 10:11:57 nomos Exp $
#
# written by Dohyun Kim <nomos at ktug dot kr>
#
# public domain
#
# see Unicode Standard Ch03 3.12

binmode STDIN,":utf8";
binmode STDOUT,":utf8";

my $cho  = "\x{1100}-\x{115F}\x{A960}-\x{A97C}";
my $jung = "\x{1160}-\x{11A7}\x{D7B0}-\x{D7C6}";
my $jong = "\x{11A8}-\x{11FF}\x{D7CB}-\x{D7FB}";

while(<>) {
	s/([$cho])([$jong])/$1\x{1160}\x{115F}\x{1160}$2/g;
	s/([$cho])(?![$jung])/$1\x{1160}/g;
	s/(?<![$cho])([$jung])/\x{115F}$1/g;
	s/(?<![$jung])([$jong])/\x{115F}\x{1160}$1/g;
	print;
}
